#include "Cannon.h"
#include "Level.h"
#include "GDMissileCommand.h"

#include <Xtreme/XRenderer.h>



Cannon::Cannon( int X, int Y, int NumMissiles ) :
  m_Pos( X, Y ),
  m_Missiles( NumMissiles )
{
}



void Cannon::Display( XRenderer& Renderer )
{
  int     numMissilesPerLine = 1;
  int     missilesLeft = m_Missiles;
  int     curY = m_Pos.y;

  while ( missilesLeft > 0 )
  {
    int   numMissilesToDraw = math::minValue( numMissilesPerLine, missilesLeft );

    for ( int i = 0; i < numMissilesToDraw; ++i )
    {
      Renderer.RenderTextureSection2d( ( m_Pos.x - 7 * numMissilesPerLine / 2 + 7 * i ) - 3, curY, theApp.Section( "Player.Missile" ) );
    }
    missilesLeft -= numMissilesToDraw;
    ++numMissilesPerLine;
    curY += 6;
  }
}



void Cannon::UpdateFixed( Level& Level )
{
}



void Cannon::Update( Level& Level, GR::f32 ElapsedTime )
{
}



