#include "GDMissileCommand.h"

#include "GSMenu.h"
#include "MCTypes.h"

#include <Controls/Xtreme/GUIComponentDisplayer.h>



GDMissileCommand           theApp;



GDMissileCommand::GDMissileCommand() :
  CXFrameApp(),
  m_LastScore( 0 ),
  m_BestScore( 0 )
{
  ConfigureApp( "GD Missile Command.assetproject", "GR Games\\GD Missile Command" );

  srand( (unsigned int)time( NULL ) );
}



GDMissileCommand::~GDMissileCommand()
{
}



void GDMissileCommand::Configure( Xtreme::EnvironmentConfig& Configuration )
{
  Configuration.StartUpWidth = 800;
  Configuration.StartUpHeight = 600;
  Configuration.FixedSize = true;
  Configuration.Caption = "GD Missile Command";
  Configuration.IconResourceID = IDI_ICON_3DAPP;

  m_IconID = Configuration.IconResourceID;
}



bool GDMissileCommand::InitInstance()
{
  if ( !CXFrameApp::InitInstance() )
  {
    return false;
  }

  if ( !RunDefaultModules() )
  {
    return false;
  }

  if ( BoundKey( MC::ControlKey::FIRE_CANNON_1 ) == 0 )
  {
    SetKeyBinding( MC::ControlKey::FIRE_CANNON_1, InputClass()->MapKeyToVKey( Xtreme::KEY_1 ) );
  }
  if ( BoundKey( MC::ControlKey::FIRE_CANNON_2 ) == 0 )
  {
    SetKeyBinding( MC::ControlKey::FIRE_CANNON_2, InputClass()->MapKeyToVKey( Xtreme::KEY_2 ) );
  }
  if ( BoundKey( MC::ControlKey::FIRE_CANNON_3 ) == 0 )
  {
    SetKeyBinding( MC::ControlKey::FIRE_CANNON_3, InputClass()->MapKeyToVKey( Xtreme::KEY_3 ) );
  }

  // TODO - das ist NICHT schn hier!
  InitialiseImplementationSpecificAssets();

  m_pRenderClass->SetState( XRenderer::RS_MINFILTER, XRenderer::RSV_FILTER_POINT );
  m_pRenderClass->SetState( XRenderer::RS_MAGFILTER, XRenderer::RSV_FILTER_POINT );
  m_pRenderClass->SetState( XRenderer::RS_MIPFILTER, XRenderer::RSV_FILTER_POINT );

  XMaterial       mat;

  ZeroMemory( &mat, sizeof( XMaterial ) );
  mat.m_dwAmbient = 0xff808080;
  m_pRenderClass->SetMaterial( mat );

  m_GUI.AddListener( &m_StateManager );

  m_StateManager.PushState( new CGSMenu() );
  return true;

}



void GDMissileCommand::ExitInstance()
{
  m_StateManager.PopAllStates();

  CXFrameApp::ExitInstance();
}



bool GDMissileCommand::ProcessEvent( const GR::Gamebase::tXFrameEvent& Event )
{
  switch ( Event.m_Type )
  {
    case GR::Gamebase::tXFrameEvent::ET_RENDERER_SWITCHED:
      break;
    case GR::Gamebase::tXFrameEvent::ET_DISPLAY_MODE_CHANGED:
      break;
  }
  return CXFrameApp::ProcessEvent( Event );
}



bool GDMissileCommand::ProcessEvent( const GUI::OutputEvent& Event )
{
  if ( m_StateManager.ProcessEvent( Event ) )
  {
    return true;
  }
  return false;
}



void GDMissileCommand::UpdatePerDisplayFrame( const float fElapsedTime )
{
  // TODO - Updates pro Frame
  m_GUI.UpdateAllControls( fElapsedTime );
}



void GDMissileCommand::UpdateFixedLogic()
{
  // Game-States
  m_StateManager.UpdateCurrentState();
}



