#ifndef GSBONUS
#define GSBONUS



#include <Xtreme/XRenderer.h>

#include <GR\GameState\GUIGameState.h>

#include <Controls\OutputEvent.h>

#include "Level.h"



namespace BonusState
{
  enum Value
  {
    DELAY_1,
    COUNT_MISSILES,
    DELAY_2,
    COUNT_CITIES,
    DELAY_3,
    COUNT_CANNONS,
    DELAY_4
  };
}



class CGSBonus : public GUIGameState<XRenderer>, public EventListener<GUI::OutputEvent>
{

  public:

    DECLARE_CLONEABLE( CGSBonus, "GSBonus" )

    BonusState::Value       m_State;

    int                     m_StateDelay;

    int                     m_CountedMissiles;
    int                     m_CountedCities;
    int                     m_CountedCannons;

    Level::tListUnits::iterator     m_UnitIterator;

    bool                    m_SkipBonus;



    virtual void            Init();
    virtual void            Exit();


    virtual void            UpdatePerDisplayFrame( const GR::f32 ElapsedTime );
    virtual void            Display( XRenderer& Viewer );
    virtual void            Update();

    virtual bool            ProcessEvent( const GUI::OutputEvent& Event );

    void                    RenderCentered( XRenderer& Renderer, XFont* pFont, int Y, const std::string& Text, GR::u32 Color );

};

#endif // GSBONUS
