#ifndef GSGAME_H
#define GSGAME_H



#include <Xtreme/XRenderer.h>

#include <GR\GameState\GUIGameState.h>

#include <Controls\OutputEvent.h>

#include "Level.h"
#include "GameLogic.h"
#include "WaveInfo.h"



class CGSGame : public GUIGameState<XRenderer>, public EventListener<GUI::OutputEvent>
{

  public:

    DECLARE_CLONEABLE( CGSGame, "GSGame" )


    Level                   m_Level;

    WaveInfo                m_WaveInfo;

    GR::u32                 m_Score;

    int                     m_WaveNumber;

    bool                    m_WaitingOnBonusToFinish;
    bool                    m_WaitForLevelToClear;
    bool                    m_AllCannonsDestroyed;
    int                     m_Cannons;
    int                     m_GameOverDelay;


    virtual void            Init();
    virtual void            Exit();


    virtual void            UpdatePerDisplayFrame( const GR::f32 ElapsedTime );
    virtual void            Display( XRenderer& Viewer );
    virtual void            Update();

    virtual bool            ProcessEvent( const GUI::OutputEvent& Event );

    void                    ShootCannon( int X, int Y, const GR::tPoint& TargetPos );

    void                    OnGameEvent( GameLogic::EventType::Value Type, Unit* pUnit, Unit* pOtherUnit, int Value );

    virtual void            OnResume();

};

#endif // GSGAME_H
