#include <Misc/CloneFactory.h>

#include "GSMenu.h"
#include "GDMissileCommand.h"




IMPLEMENT_CLONEABLE( CGSMenu, "GSMenu" )



void CGSMenu::Init()
{
  m_Menu.Add( 0 );
  m_Menu.Add( 1 );
  m_Menu.Add( 2 );

  m_Level.m_Cannons.push_back( Cannon( 75, 560, 10 ) );
  m_Level.m_Cannons.push_back( Cannon( 400, 560, 10 ) );
  m_Level.m_Cannons.push_back( Cannon( 725, 560, 10 ) );

  int     cityOffset = ( 400 - 75 ) / 4;

  m_Level.SpawnUnit( "Cannon", 75, 530, 0 );
  m_Level.SpawnUnit( "Cannon", 400, 530, 1 );
  m_Level.SpawnUnit( "Cannon", 725, 530, 2 );

  m_Level.SpawnUnit( "City", 75 + 1 * cityOffset, 530, 0 );
  m_Level.SpawnUnit( "City", 75 + 2 * cityOffset, 530, 1 );
  m_Level.SpawnUnit( "City", 75 + 3 * cityOffset, 530, 2 );
  m_Level.SpawnUnit( "City", 400 + 1 * cityOffset, 530, 3 );
  m_Level.SpawnUnit( "City", 400 + 2 * cityOffset, 530, 4 );
  m_Level.SpawnUnit( "City", 400 + 3 * cityOffset, 530, 5 );
}



void CGSMenu::Exit()
{
  // TODO - GUIScreen entfernen
}



void CGSMenu::UpdatePerDisplayFrame( const GR::f32 ElapsedTime )
{
  if ( theApp.InputClass()->ReleasedKeyPressed( Xtreme::KEY_ESCAPE ) )
  {
    GLOBAL_QUEUE.PostEvent( "App.ShutDown" );
  }
  if ( theApp.InputClass()->ReleasedKeyPressed( Xtreme::KEY_P ) )
  {
    ChangeState( "GSGame" );
  }
  if ( theApp.InputClass()->ReleasedKeyPressed( Xtreme::KEY_O ) )
  {
    ChangeState( "GSOptions" );
  }

  m_Menu.Update( ElapsedTime );
  if ( m_Menu.Done() )
  {
    m_Menu.SetUndone();
    switch ( m_Menu.SelectedItem() )
    {
      case 0:
        ChangeState( "GSGame" );
        break;
      case 1:
        ChangeState( "GSOptions" );
        break;
      case 2:
        GLOBAL_QUEUE.PostEvent( "App.ShutDown" );
        break;
    }
  }
}



void CGSMenu::Display( XRenderer& Renderer )
{
  Renderer.SetShader( XRenderer::ST_FLAT_NO_TEXTURE );
  Renderer.RenderQuad2d( 0, 0, 800, 530, 0xff1FE2FF, 0xff1FE2FF, 0xff4AB1BF, 0xff4AB1BF );
  Renderer.RenderQuad2d( 0, 530, 800, 70, 0xff40c040 );

  Renderer.SetShader( XRenderer::ST_ALPHA_TEST );
  m_Level.Display( Renderer );

  m_Menu.Display( Renderer );

  Renderer.SetShader( XRenderer::ST_ALPHA_TEST );
  Renderer.RenderText2d( theApp.Font( "GUI" ), 5, 2, ( Misc::Format( "SCORE %01:6%" ) << theApp.m_LastScore ).Result().c_str(), 2.0f, 2.0f, 0xffffffff );

  std::string     hiScore = Misc::Format( "HI %01:6%" ) << theApp.m_BestScore;
  int     textLength = theApp.Font( "GUI" )->TextLength( hiScore.c_str() );
  Renderer.RenderText2d( theApp.Font( "GUI" ), ( 800 - textLength * 2 ) / 2, 2, hiScore.c_str(), 2.0f, 2.0f, 0xffffffff );

  textLength = theApp.Font( "GUI" )->TextLength( "GameDev Missile Command" );
  Renderer.RenderText2d( theApp.Font( "GUI" ), ( 800 - textLength * 4 ) / 2, 50, "GameDev Missile Command", 4.0f, 10.0f, 0xffffffff );
}



void CGSMenu::Update()
{
  // TODO - Update
}



bool CGSMenu::ProcessEvent( const GUI::OutputEvent& Event )
{
  // TODO - Auf GUI-Events reagieren
  switch ( Event.Type )
  {
    case OET_BUTTON_PUSHED:
      break;
  }
  return false;
}
