#ifndef GAMELOGIC_H
#define GAMELOGIC_H



#include <Lang/FastDelegate.h>

#include <GR/GRTypes.h>

#include "Unit.h"



class XRenderer;
class UnitController;
class Level;
class WaveInfo;



namespace GameLogic
{
  namespace EventType
  {
    enum Value
    {
      ET_SCORE_CHANGED = 1,
      ET_ENEMY_KILLED,
      ET_MISSILE_HIT,
      ET_CANNON_DESTROYED
    };
  }


  typedef fastdelegate::FastDelegate4<EventType::Value, Unit*, Unit*, int>    tGameEventHandler;

  extern tGameEventHandler      _GameEventHandler;
  

  void RaiseGameEvent( EventType::Value Type, Unit* pUnit, Unit* pOtherUnit = NULL, int Value = 0 );
  void RaiseGameEvent( EventType::Value Type, int Value );

  void MissileHits( Level& Level, const GR::tPoint& Pos );

  void PrepareWave( Level& Level, int WaveNo, WaveInfo& Wave );

};

#endif // GAMELOGIC_H
