#pragma once

#include <Interface/IIOStream.h>

#include <Lang/FastDelegate.h>

#include <list>

#include "Unit.h"
#include "Cannon.h"


class XRenderer;

class Level
{

  public:

    typedef std::list<Unit>       tListUnits;
    typedef std::vector<Cannon>   tListCannons;


    tListUnits                        m_Units;

    tListCannons                      m_Cannons;

    GR::f32                           m_FixedTime;



    Level();
    ~Level();


    void                              Display( XRenderer& Renderer );
    void                              Update( const GR::f32 ElapsedTime );
    void                              UpdateFixed();

    void                              UpdateUnits( GR::f32 ElapsedTime );
    void                              UpdateUnitsFixed();

    void                              Clear();
    void                              RemoveTempUnits();

    GR::u32                           OnCollision( Unit& Unit1, Unit& Unit2 );

    Unit*                             SpawnUnit( const std::string& Type, int X, int Y, int UnitIndex = 0 );

    bool                              MoveUnit( Unit& Unit, const GR::tFPoint& Delta );

    bool                              IsBlocked( Unit& MovingUnit, int DX, int DY, Unit*& pBlockingUnit );

    void                              ExplodeObjects( const GR::tPoint& ExplosionCenter, GR::f32 ExplosionRadius );

    bool                              UnitIsExplodeable( Unit& Unit );


    void                              SpawnMissile( GR::f32 MissileSpeed );

    bool                              IsWaveComplete();
    bool                              IsClear();

    int                               NumberOfCannonsLeft();
    int                               NumberOfCitiesLeft();

};
