#include ".\PlayerMissileController.h"
#include ".\Level.h"
#include ".\HurtingExplosionController.h"

#include "GDMissileCommand.h"



PlayerMissileController::PlayerMissileController()
{
}



PlayerMissileController::~PlayerMissileController()
{
}



void PlayerMissileController::Update( Level& Level, Unit& Unit, GR::f32 ElapsedTime )
{
  It.NextValue( ElapsedTime );

  Unit.m_Pos.x = (int)( StartPos.x + ( TargetPos.x - StartPos.x ) * It.Value() );
  Unit.m_Pos.y = (int)( StartPos.y + ( TargetPos.y - StartPos.y ) * It.Value() );

  if ( It.Done() )
  {
    // TODO - explode target
    auto pExplosion = Level.SpawnUnit( "HurtingExplosion", Unit.m_Pos.x, Unit.m_Pos.y );
    ( (HurtingExplosionController*)pExplosion->m_pController )->m_ExplosionSizeChanger.AddIterator( new math::Iterator::SlowingIterator( 0.0f, 2.5f, 1.0f ) );
    ( (HurtingExplosionController*)pExplosion->m_pController )->m_ExplosionSizeChanger.AddIterator( new math::Iterator::Linear( 2.5f, 0.0f, 1.0f ) );
    Unit.m_RemoveMe = true;

    theApp.SoundClass()->Play( theApp.Sound( Misc::Format( "Explosion.%1%" ) << rand() % 2 + 1 ) );
  }
}



void PlayerMissileController::UpdateFixed( Level& Level, Unit& Unit )
{
}



