#ifndef UNIT_H
#define UNIT_H



#include <Interface/IAnimationManager.h>

#include <GR/GRTypes.h>

#include "Unit.h"



class XRenderer;
class UnitController;
class UnitDisplayer;
class Level;

class Unit
{

  public:

    GR::tPoint              m_Pos;

    GR::tFPoint             m_FractPos;
    GR::tFPoint             m_Speed;

    std::string             m_Template;

    std::string             m_Image;
    std::string             m_Animation;
    tAnimationPos           m_AnimPos;
    bool                    m_RemoveMe;
    int                     m_LifeTime;

    GR::tRect               m_Bounds;

    UnitController*         m_pController;
    UnitDisplayer*          m_pDisplayer;

    GR::f32                 m_DisplayAngle;

    GR::f32                 m_DisplayZoomFactor;

    int                     m_UnitIndex;



    Unit();
    ~Unit();

    void                    Display( XRenderer& Viewer );
    void                    UpdateFixed( Level& Level );
    void                    Update( Level& Level, GR::f32 ElapsedTime );

    void                    SetImage( const std::string& Image );
    void                    SetAnimation( const std::string& Animation );

    GR::tRect               CollisionBounds();

};

#endif // UNIT_H
