#include "WaveInfo.h"
#include "Level.h"



WaveInfo::WaveInfo() :
  m_CurrentFrame( 0 )
{
}



void WaveInfo::Clear()
{
  m_MissileWaves.clear();
  m_CurrentFrame = 0;
}



void WaveInfo::Update( Level& Level )
{
  if ( m_MissileWaves.empty() )
  {
    return;
  }
  tMissileWaves::iterator   it( m_MissileWaves.find( m_CurrentFrame ) );
  if ( it == m_MissileWaves.end() )
  {
    ++m_CurrentFrame;
    return;
  }

  int     numMissilesToSpawn = it->second;

  for ( int i = 0; i < numMissilesToSpawn; ++i )
  {
    Level.SpawnMissile( m_MissileSpeed );
  }
  m_MissileWaves.erase( it );

  ++m_CurrentFrame;
}



